#include "stdafx.h"
#include "SequenceElement.h"
#include "EdgeConditions.h"
#include "Arithmetic.h"

bool distance_condition::operator()(const CodedSequence_t& rFirst, const CodedSequence_t& rSecond) const
{
	CodedSequence_t::const_iterator firstIter = rFirst.begin();
	CodedSequence_t::const_iterator firstEnd = rFirst.end();

	CodedSequence_t::const_iterator secondEnd = rSecond.end();

	int nTotalFirst = std::accumulate(rFirst.begin(), rFirst.end(), 0, add_seconds<CodedSequence_t::value_type>());
	int nTotalSecond = std::accumulate(rSecond.begin(), rSecond.end(), 0, add_seconds<CodedSequence_t::value_type>());

	int nRemainingFirst = 0;
	int nRemainingSecond = 0;
	int nTotalSecondExamined = 0;

	for (; firstIter != firstEnd; ++firstIter)
	{
		GroupElement* pFirstBase = firstIter->first;
		int nFirstExp = firstIter->second;

		CodedSequence_t::const_iterator iter2 = rSecond.find(pFirstBase);
		if (iter2 != rSecond.end())
		{
			int nSecondExp = iter2->second;
			nRemainingFirst += _max(nFirstExp - nSecondExp, 0);
			nRemainingSecond += _max(nSecondExp - nFirstExp, 0);
			nTotalSecondExamined += nSecondExp;
		}
		else
			nRemainingFirst += nFirstExp;
	}

	nRemainingSecond += nTotalSecond - nTotalSecondExamined;

	return _max(nRemainingFirst, nRemainingSecond) == m_n;
}
