#ifndef __UTILITY_H__
#define __UTILITY_H__

#include "Typedef.h"
class Group;
class FiniteAbelianGroup;

#ifdef USE_WINDOWS_CODE
	extern DWORD g_dwTimer;
#endif

#ifdef	_DEBUG
	#define debug_dynamic_cast dynamic_cast
#else
	#define debug_dynamic_cast static_cast
#endif

template<class T>
struct add_seconds
	: public std::binary_function<T, T, T::second_type>
{
	T::second_type operator()(T::second_type t, const T& t2)
	{
		return t + t2.second;
	}
};

template<class T>
T mymin(T lhs, T rhs)
{
	return (lhs < rhs) ? lhs : rhs;
}

template<class T>
T mymax(T lhs, T rhs)
{
	return (lhs > rhs) ? lhs : rhs;
}

std::ostream& operator << (std::ostream& stream, const Sequence_t& rSequence);
std::ostream& operator << (std::ostream& stream, const Set_t& rSet);
std::ostream& operator << (std::ostream& stream, const CodedSequence_t& rSequence);

struct sequence_encoder
	: public std::unary_function<Sequence_t, CodedSequence_t>
{
	sequence_encoder(const Group& g)
		: m_g(g)
	{
	}

	CodedSequence_t operator()(const Sequence_t& s) const;

private:
	const Group& m_g;
};

struct str_starts_with
	: public std::binary_function<std::string, std::string, bool>
{
	str_starts_with() {}
	bool operator()(const std::string& strLHS, const std::string& strRHS) const;
};

template<class T>
struct str_contains
	: public std::binary_function<std::string, T, bool>
{
	bool operator()(const std::string& strLHS, const T& rhs) const
	{
		std::string::size_type pos = strLHS.find(rhs);

		return (pos != std::string::npos);
	}

};

inline std::string BoolToStr(bool b, std::string yes, std::string no)
{
	if (b)
		return yes;

	return no;
};

class StringTokenizer
{
public:
	StringTokenizer()
		: m_str(""), m_Delim(0), m_Pos(0)
	{
	}

	bool		Done() const;
	std::string	Next();
	void		Begin(const std::string& str, char delim);

private:
	std::string				m_str;
	std::string::size_type	m_Pos;
	char					m_Delim;
};

void SetToVectorBool(const FiniteAbelianGroup& g, const Set_t& rSet, std::vector<bool>& rVector);

void VectorBoolToSet(const FiniteAbelianGroup& g, const std::vector<bool>& rVector, Set_t& rSet);
void VectorBoolToSet(const FiniteAbelianGroup& g, std::vector<bool>::const_iterator iter, std::vector<bool>::const_iterator iterEnd, Set_t& rSet);

/*class Timer
{
public:
	Timer(DWORD& rDword)
		: m_dword(rDword)
	{
		m_start = timeGetTime();
	}

	~Timer()
	{
		m_dword += timeGetTime() - m_start;
	}

private:
	DWORD m_start;
	DWORD& m_dword;
};*/
#endif